Subject: Re: bug#50264: ca-certificate-bundle fails to build

From: Leo Famulari <[email-masked]>
Date: Tue, 14 Sep 2021 12:04:22 -0400

On Tue, Sep 14, 2021 at 03:08:19PM +0200, Ludovic Courtès wrote:
> Hi,
> 
> Lars-Dominik Braun <[email-masked]> skribis:
> 
> > Failure:
> > /gnu/store/kxkxji6m101ylgpa82jmxvmy5szpvk1k-ca-certificate-bundle.drv
> > /gnu/store/wahy9p8985vbcibwwjk3p73hxh82f90v-ca-certificate-bundle-builder
> >
> > Success:
> > /gnu/store/rx6pqcpgwcyl6spfi8acgjzksrpqhac1-ca-certificate-bundle.drv
> > /gnu/store/wahy9p8985vbcibwwjk3p73hxh82f90v-ca-certificate-bundle-builder
> >
> > (Yes, exactly the same builder input hash. I double-checked.)
> 
> As discussed on IRC, I stumbled upon this bug while running:
> 
>   ./pre-inst-env guix system vm gnu/system/examples/desktop.tmpl
> 
> on commit 580984f2417853379d98ea927fd95c0f0fbe2c97.
> 
> The first attempt downloaded lots of substitutes and produced, as in
> your case, a broken ca-certificate-bundle.drv: the ‘-builder’ script is
> correct, but there are only ~80 derivation inputs instead of ~230.
> 
> The second run right after that produced the correct
> ca-certificate-bundle.drv: same ‘-builder’ script, but all the
> derivation inputs were there, including glibc-utf8-locales.drv.
> 
> I’ve tried to reproduce it running GC during or before the command, to
> no avail so far.  If someone has an easy and reliable way to reproduce
> it, please share!
> 
> I don’t have a good hypothesis so far as to where things go wrong…

I wonder if the problem began after the introduction of
bordeaux.guix.gnu.org, and if everyone who experiences the bug is using
both substitute servers.

I can't imagine what the actual problem is, but it does sound like the
dependency graph has somehow diverged...